from django import forms
from .models import PCTLProperty
from .fields import ListTextWidget

class PCTLPropertyForm(forms.ModelForm):
	class Meta:
		model = PCTLProperty
		fields = '__all__'
        

	def __init__(self, *args, **kwargs):
		#_type_list = kwargs.pop('data_list', None)
		super(PCTLPropertyForm, self).__init__(*args, **kwargs)
		 
		res_list = (x[0] for x in PCTLProperty._meta.get_field('property_type').choices)
		# the "name" parameter will allow you to use the same widget more than once in the same
		# form, not setting this parameter differently will cuse all inputs display the
		# same list.
		self.fields['property_type'].widget = ListTextWidget(data_list=res_list, name='property-type-list')

