from __future__ import unicode_literals
from django.db import models
from django.utils.encoding import python_2_unicode_compatible
from django import forms
from .fields import CharFieldWithTextarea
from elasticity.models import Elasticity

@python_2_unicode_compatible
class PCTLProperty(models.Model):
	class Meta:
		verbose_name = u'PCTLProperty'
		verbose_name_plural = u'PCTLProperties'

	TYPES_CHOICES = (
		('CUSTOM', u'Custom'),
		('WHAT_IF', u'What if'),
		('METRIC_EVOLVE', u'Metric Evolve')
	    )
	pctl_text = models.CharField(max_length=2000, verbose_name="PCTL Property") #help_text="The PCTL property you want to verify")
	description = CharFieldWithTextarea(max_length=2000)
	property_type = models.CharField(max_length=20, choices=TYPES_CHOICES)
	elasticity_manager_id = models.ForeignKey(Elasticity, on_delete=models.CASCADE, verbose_name="Elasticity Manager", null=True)
	elasticity_restrictions = models.CharField(default="add,remove,no_op", max_length=2000, verbose_name="Allowed Elasticity Actions")

	def __str__(self):
        	return self.pctl_text


