from django.conf.urls import url

from . import views

app_name = 'analysis'
urlpatterns = [
    url(r'^$', views.IndexView.as_view(template_name = 'analysis/pctl_list.html'), name='pctl_index'),
    # ex: /analysis/5/
    url(r'^(?P<pctl_property_id>[0-9]+)/$', views.update, name='detail'),
    # ex: /analysis/5/delete/
    url(r'^(?P<pctl_property_id>[0-9]+)/delete/$', views.delete, name='delete'),
    # ex: /analysis/5/update/
    url(r'^(?P<pctl_property_id>[0-9]+)/update/$', views.update, name='update'),
    # ex: /analysis/create/
    url(r'create/$', views.create, name='create'),
    # ex: /analysis/5/verify/
    url(r'^(?P<pctl_property_id>[0-9]+)/verify/$', views.verify, name='verify'),
    # ex: /analysis/5/verification_dashboard/
    url(r'^(?P<pctl_property_id>[0-9]+)/verification_dashboard/$', views.verification_dashboard, name='verification_dashboard'),
    # ex: /analysis/5/download_model/
    url(r'^(?P<pctl_property_id>[0-9]+)/download_model/$', views.download_model, name='download_model'),
]
