from pysqlite2 import dbapi2 as sqlite
import sys, time, fileinput, shutil, pexpect, logging, paramiko, os, json, requests, shutil
import logging.handlers
import Utils
from Client import Client
from threading import Thread

headers = {
    "accept": "application/json",
    "content-type": "application/json",
    "user-agent": "Ganeti RAPI Client",
}

class ClientsController(object):
    '''

    '''


    def __init__(self, properties_file, decisionMaker):
        '''
        Constructor
        ''' 
#	devnull = open(os.devnull, 'w')
#	sys.stdout = devnull
#	sys.stderr = devnull
        self.utils = Utils.Utils(properties_file)
	self.base_url = 'https://192.168.1.6:5080/2/'
	self.username = "ganeti_webmgr"
	self.password = "9CCNPcF4SJyX"

	self.decisionMaker = decisionMaker

	## Install logger
        LOG_FILENAME = self.utils.install_dir+'/'+self.utils.logs_folder_name +'/ClientsController.log'
        self.my_logger = logging.getLogger('ClientsController')
        self.my_logger.setLevel(self.utils.logging_level)
        
        handler = logging.handlers.RotatingFileHandler(
                      LOG_FILENAME, maxBytes=2*1024*1024, backupCount=5)
        formatter = logging.Formatter("%(asctime)s - %(levelname)s - %(name)s - %(message)s")
        handler.setFormatter(formatter)
        self.my_logger.addHandler(handler)

#        Make sure the sqlite file exists. if not, create it and the table we need
        con = sqlite.connect(self.utils.db_file)
        cur = con.cursor()
        try:
            clients = cur.execute('select * from clients'
                            ).fetchall()
            
            print "Found client records:\n", clients
        except sqlite.DatabaseError:
            cur.execute('create table clients(id text, ip_address text, username text, password text)')
            con.commit()
            
        cur.close()
        con.close()
        self.period = 600;
	self.finished = False;

	self.running_client_threads = 0
	self.client_threads_mapping = {}

    def configure_clients(self, clients=None):
	self.my_logger.debug("Configuring clients...")
	instance_ips = self.get_cluster_ips()
	clid = 0
	node_id = 0
	for client in clients:
		ssh = paramiko.SSHClient()
		ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
		self.my_logger.debug("Starting config for node: " + client.ip_address) 
		ssh.connect(client.ip_address, username=client.username, password=client.password)
		stdin, stdout, stderr = ssh.exec_command('ulimit -n 1000000')
		ssh.close()

		transport = paramiko.Transport((client.ip_address, 22))
		transport.connect(username = client.username, password = client.password)
		transport.open_channel("session", client.ip_address, "localhost")
		sftp = paramiko.SFTPClient.from_transport(transport)
		if self.utils.cluster_type == "INFINISPAN":
			shutil.copy("../templates/infinispan/scripts/infinispan-hotrod-load.sh", "/tmp/infinispan-hotrod-load.sh")
			load_script = "/tmp/infinispan-hotrod-load.sh"
			shutil.copy("../templates/infinispan/scripts/infinispan-hotrod-read.sh", "/tmp/infinispan-hotrod-read.sh")
			read_script = "/tmp/infinispan-hotrod-read.sh"
			shutil.copy("../templates/infinispan/scripts/infinispan-hotrod-read-async.sh", "/tmp/infinispan-hotrod-read-async.sh")
			read_async_script = "/tmp/infinispan-hotrod-read-async.sh"
		elif self.utils.cluster_type == "CASSANDRA223":
			shutil.copy("../templates/cassandra223/scripts/cassandra2-load.sh", "/tmp/cassandra2-load.sh")
			load_script = "/tmp/cassandra2-load.sh"
			shutil.copy("../templates/cassandra223/scripts/cassandra2-read.sh", "/tmp/cassandra2-read.sh")
			read_script = "/tmp/cassandra2-read.sh"
			shutil.copy("../templates/cassandra223/scripts/cassandra2-read-async.sh", "/tmp/cassandra2-read-async.sh")
			read_async_script = "/tmp/cassandra2-read-async.sh"

		if(node_id == 0):
			shutil.copy("../templates/ycsb/run_master.sh", "/tmp/run_master.sh")
		else:
			shutil.copy("../templates/ycsb/run.sh", "/tmp/run.sh")
		run = "/tmp/run.sh"
		run_master = "/tmp/run_master.sh"
		
		sftp.put( "../templates/network/bandwidth_limit_cl.sh","/root/bandwidth_limit.sh")
		

		for line in fileinput.FileInput(load_script,inplace=1):
		         line = line.replace("MINMEM",str(int(int(self.utils.client_ram)*0.3))).strip()
			 line = line.replace("MAXMEM",str(int(int(self.utils.client_ram)*0.9))).strip()
			 print line
		
		for line in fileinput.FileInput(read_script,inplace=1):
		         line = line.replace("MINMEM",str(int(int(self.utils.client_ram)*0.3))).strip()
			 line = line.replace("MAXMEM",str(int(int(self.utils.client_ram)*0.9))).strip()
			 print line
		
		for line in fileinput.FileInput(read_async_script,inplace=1):
		         line = line.replace("MINMEM",str(int(int(self.utils.client_ram)*0.2))).strip()
			 line = line.replace("MAXMEM",str(int(int(self.utils.client_ram)*0.2))).strip()
			 print line
		
		if self.utils.cluster_type == "INFINISPAN":
			sftp.put( load_script,"/opt/YCSB/infinispan-hotrod-load.sh")
			sftp.put( read_script,"/opt/YCSB/infinispan-hotrod-read.sh")
			sftp.put( read_async_script,"/opt/YCSB/infinispan-hotrod-read-async.sh")
		elif self.utils.cluster_type == "CASSANDRA223":
			sftp.put( load_script,"/opt/YCSB/cassandra2-load.sh")
			sftp.put( read_script,"/opt/YCSB/cassandra2-read.sh")
			sftp.put( read_async_script,"/opt/YCSB/cassandra2-read-async.sh")

		if(node_id == 0):
			for line in fileinput.FileInput(run_master,inplace=1):
				 line = line.replace("MULTI",str(clid)).strip()
				 line = line.replace("PERIOD",str(self.period)).strip()
				 line = line.replace("RUNTIME",str(27*self.period)).strip()
	#			 line = line.replace("PERIOD",str(1800)).strip()
	#			 line = line.replace("RUNTIME",str(43200)).strip()
	#			 line = line.replace("PERIOD",str(1800)).strip()
	#			 line = line.replace("RUNTIME",str(28800)).strip()
				 line = line.replace("IPS",str(instance_ips)).strip()
				 line = line.replace("CLIENTID",str(clid)).strip()
				 print line
				 clid = clid + 1
			sftp.put( run_master,"/opt/YCSB/run.sh")
		else:
			lnum = 0
			for line in fileinput.FileInput(run,inplace=1):
				 line = line.replace("MULTI",str(clid-4)).strip()
				 line = line.replace("PERIOD",str(self.period)).strip()
				 line = line.replace("RUNTIME",str(27*self.period)).strip()
	#			 line = line.replace("PERIOD",str(1800)).strip()
	#			 line = line.replace("RUNTIME",str(43200)).strip()
	#			 line = line.replace("PERIOD",str(1800)).strip()
	#			 line = line.replace("RUNTIME",str(28800)).strip()
				 line = line.replace("IPS",str(instance_ips)).strip()
				 line = line.replace("CLIENTID",str(clid)).strip()
				 print line
				 if lnum == 1 or lnum == 3 or lnum == 5:
				 	clid = clid + 1
				 lnum = lnum + 1
			sftp.put( run,"/opt/YCSB/run.sh")
		sftp.put( "../templates/ycsb/ycsb.jar", "/opt/YCSB/build/ycsb.jar")

		if self.utils.cluster_type == "INFINISPAN":
			sftp.put( "../templates/ycsb/workloadaasyncispn", "/opt/YCSB/workloads/workloadaasyncispn")
		elif self.utils.cluster_type == "CASSANDRA223":
			sftp.put( "../templates/ycsb/workloadreadasynccassandra", "/opt/YCSB/workloads/workloadreadasynccassandra")
		sftp.close()

		ssh = paramiko.SSHClient()
		ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
		ssh.connect(client.ip_address, username=client.username, password=client.password)
		self.my_logger.debug("Bandwidth_limit")
	    	#stdin, stdout, stderr = ssh.exec_command('cd /root; chmod 755 bandwidth_limit.sh; ./bandwidth_limit.sh')
	    	self.my_logger.debug(str(stdout.readlines()))
	    	self.my_logger.debug(str(stderr.readlines()))
		ssh.close()

		clid = clid + 1
		node_id = node_id + 1
	self.update_hosts_file(clients)

	

    def update_hosts_file(self, clients=None):
	#Creating /etc/hosts file
	cluster = self.utils.get_cluster(self.utils.cluster_name)
	hosts = ""
	for instance in cluster:
		hosts = hosts + (str(instance[2])+"\t"+str(instance[1])+"\n")

	shutil.copy("../templates/hbase94/hosts", "/tmp/hosts")
	hosts_file = '/tmp/hosts'

	for line in fileinput.FileInput(hosts_file,inplace=1):
            line = line.replace("HOSTNAMES",hosts).strip()
            print line
	
	for client in clients:
		self.my_logger.debug("Sending hosts file to: " + client.ip_address)
		self.my_logger.debug(client.username + " " + client.password)
		transport = paramiko.Transport((client.ip_address, 22))
		transport.connect(username = client.username, password = client.password)
		transport.open_channel("session", client.ip_address, "localhost")
		sftp = paramiko.SFTPClient.from_transport(transport)
		sftp.put( hosts_file,"/etc/hosts")
		#Copy private and public key
		sftp.put( "../templates/ssh_keys/id_rsa","/root/.ssh/id_rsa")
		sftp.put( "../templates/ssh_keys/id_rsa.pub", "/root/.ssh/id_rsa.pub")
		sftp.put( "../templates/ssh_keys/config", "/root/.ssh/config")
	        sftp.put( "../templates/ssh_keys/authorized_keys", "/root/.ssh/authorized_keys")

		ssh = paramiko.SSHClient()
		ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
		ssh.connect(client.ip_address, username=client.username, password=client.password)

		## Change permissions for private key
		stdin, stdout, stderr = ssh.exec_command('chmod 0600 /root/.ssh/id_rsa')

		# Add public key to authorized_keys
		stdin, stdout, stderr = ssh.exec_command('cat /root/.ssh/id_rsa.pub >> /root/.ssh/authorized_keys')
		sftp.close()


    def run_experiment(self, clients, limit):
	#self.load_db(clients)
	self.read_with_limit(clients, limit)

    def get_cluster_ips(self, separator=","):
	instance_ips = ""
	## read from the local database
	con = sqlite.connect(self.utils.db_file)
	cur = con.cursor()
	instancesfromDB = []
	try:
		instancesfromDB = cur.execute('select * from instances'
		    ).fetchall()
	except sqlite.DatabaseError:
		con.rollback()

	cur.close()
	con.close()

	i = 0
	for instancefromDB in instancesfromDB:
		if i > 0:
			instance_ips = instance_ips + separator + self.utils.return_instance_from_tuple(instancefromDB).ip_address
		else:
			instance_ips = 	self.utils.return_instance_from_tuple(instancefromDB).ip_address		
		i = i + 1
	self.my_logger.debug("Instance IPs: " + instance_ips)
	return instance_ips

    def load_db(self, clients):
	if self.utils.cluster_type == "INFINISPAN":
		instance_ips = self.get_cluster_ips()
		ssh = paramiko.SSHClient()
		ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
		self.my_logger.debug("Start loading db for experiment...") 
		ssh.connect(clients[0].ip_address, username=clients[0].username, password=clients[0].password)
		stdin, stdout, stderr = ssh.exec_command('sh /opt/YCSB/infinispan-hotrod-load.sh 20 20000 workloadread '+instance_ips+' 2000000 -1 0 | tee /root/load.log')	
		self.my_logger.debug("Errors: " + str(stderr.readlines()))
		self.my_logger.debug("STDOUT: " + str(stdout.readlines()))
		ssh.close()
	elif  self.utils.cluster_type == "HBASE94":
		#they use an other way to get to hostname (see HBase94Cluster.py 41-52)
		master_instance = self.utils.get_instance_from_cluster_db(self.utils.cluster_name, self.utils.hostname_template+"master")
		ssh = paramiko.SSHClient()
		ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
		self.my_logger.debug("Start loading db for experiment...") 
		ssh.connect(clients[0].ip_address, username=clients[0].username, password=clients[0].password)
	#	stdin, stdout, stderr = ssh.exec_command('sh /root/YCSB-0.1.3/hbase-load.sh 1 1000 workloadread '+str(master_instance[2])+' 1000000 -1 0 | tee /root/load.log')
		stdin, stdout, stderr = ssh.exec_command('sh /root/YCSB-0.1.3/hbase-load.sh 10 10000 workloadread '+str(master_instance[2])+' 10000 -1 0 | tee /root/load.log')	
		self.my_logger.debug("Errors: " + str(stderr.readlines()))
		self.my_logger.debug("STDOUT: " + str(stdout.readlines()))
		ssh.close()
	elif self.utils.cluster_type == "CASSANDRA223":
		instance_ips = self.get_cluster_ips()
		ssh = paramiko.SSHClient()
		ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
		self.my_logger.debug("Start loading db for experiment...") 
		ssh.connect(clients[0].ip_address, username=clients[0].username, password=clients[0].password)
		stdin, stdout, stderr = ssh.exec_command('sh /opt/YCSB/cassandra2-load.sh 20 20000 workloadread '+instance_ips+' 20000000 -1 0 2>&1 | tee /root/load.log')	
		self.my_logger.debug("Errors: " + str(stderr.readlines()))
		self.my_logger.debug("STDOUT: " + str(stdout.readlines()))
		ssh.close()
	self.my_logger.debug("Sleeping for 2 mins to allow DB load balancer do its job")
	time.sleep(120)
	self.my_logger.debug("OK! DB balanced")

    def run_command(self, ip, action, timeout=10000):
	if('start' in action):
		threads = int(action.split("_")[1])
		instance_ips = self.get_cluster_ips()
		for i in range(0,threads):
			shutil.copy("../templates/ycsb/run_stabilize.sh", "/tmp/run_stabilize.sh")
			run = "/tmp/run_stabilize.sh"
			transport = paramiko.Transport((ip, 22))
			transport.connect(username = "root", password = "secretpw")
			transport.open_channel("session", ip, "localhost")
			sftp = paramiko.SFTPClient.from_transport(transport)
			for line in fileinput.FileInput(run,inplace=1):
				 line = line.replace("RUNTIME",str(timeout)).strip()
				 line = line.replace("IPS",str(instance_ips)).strip()
				 line = line.replace("CLIENTID",str(self.running_client_threads)).strip()
				 print line
			sftp.put( run,"/opt/YCSB/run_stabilize"+str(self.running_client_threads)+".sh")
			sftp.close()
			ssh = paramiko.SSHClient()
			ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
			ssh.connect(ip, username='root', password='secretpw')
			ssh.exec_command('cd /opt/YCSB; sh /opt/YCSB/run_stabilize'+str(self.running_client_threads)+'.sh > /opt/YCSB/read.log 2>&1 &')
			ssh.close()
			self.running_client_threads = self.running_client_threads + 1
			self.client_threads_mapping.setdefault(ip,[]).append('run_stabilize'+str(self.running_client_threads)+'.sh')
	elif('stop_client' in action):
		if('all' in action):
			if(ip in self.client_threads_mapping.keys()):
				ssh = paramiko.SSHClient()
				ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
				ssh.connect(ip, username='root', password='secretpw')
				ssh.exec_command('touch killer.sh; echo "ps aux | grep timeout | grep -v grep | head -n'+str(len(self.client_threads_mapping[ip]))+' | awk \'{print \$2}\' | xargs kill" > killer.sh; /bin/sh killer.sh')
				ssh.close()
				del self.client_threads_mapping[ip]
		else:
			threads = int(action.split("_")[2])
			if(ip in self.client_threads_mapping.keys()):
				ssh = paramiko.SSHClient()
				ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
				ssh.connect(ip, username='root', password='secretpw')
				ssh.exec_command('touch killer.sh; echo "ps aux | grep timeout | grep -v grep | head -n'+str(threads)+' | awk \'{print \$2}\' | xargs kill" > killer.sh; /bin/sh killer.sh')
				ssh.close()
	elif(action == 'stop_all'):
		ssh = paramiko.SSHClient()
		ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
		ssh.connect(ip, username='root', password='secretpw')
		for client in self.client_threads_mapping.keys():
			ssh = paramiko.SSHClient()
			ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
			ssh.connect(client, username='root', password='secretpw')
			ssh.exec_command('touch killer.sh; echo "ps aux | grep timeout | grep -v grep | head -n'+str(len(self.client_threads_mapping[client]))+' | awk \'{print \$2}\' | xargs kill" > killer.sh; /bin/sh killer.sh')
			ssh.close()
			del self.client_threads_mapping[client]
		ssh.close()
	elif(action == 'exit'):
		exit(0)




    def read(self, clients):
	#they use an other way to get to hostname (see HBase94Cluster.py 41-52)
	master_instance = self.utils.get_instance_from_cluster_db(self.utils.cluster_name, self.utils.hostname_template+"master")
	loops = 1;
	threads = 1;	
	target = 2000;
	while(loops <= 2):
		for i in range(0,len(clients)):
			self.my_logger.debug(str(i+1)+","+str(threads)+"," + str(threads*target))
			ssh = paramiko.SSHClient()
			ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
			ssh.connect(clients[i].ip_address, username=clients[i].username, password=clients[i].password)
			ssh.exec_command('sh /root/YCSB-0.1.3/hbase-read.sh '+str(threads)+' '+str(threads*target)+' 0 '+str(self.utils.hostname_template+"master")+' 150000000 '+str(master_instance[2])+':'+str(self.utils.hostname_template+"master")+' '+str(i)+ ' > /root/read.log 2>&1 &')
			ssh.close()
			time.sleep(1200)

		for i in range(0,len(clients)-1):
			self.my_logger.debug(str(len(clients)-i-1)+","+str(threads)+"," + str(threads*target))
			ssh = paramiko.SSHClient()
			ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
			self.my_logger.debug("Killing java on: " + str(clients[i].ip_address)) 
			ssh.connect(clients[i].ip_address, username=clients[i].username, password=clients[i].password)	
			ssh.exec_command('pkill -9 java')
			ssh.close()
			time.sleep(1200)
		loops = loops + 1;
	self.my_logger.debug("finished")

    def read_with_limit(self, clients, limit):
	if self.utils.cluster_type == "INFINISPAN" or self.utils.cluster_type == "CASSANDRA223":
		j = 0;
		while j < limit:
			for i in range(0,len(clients)):
				self.my_logger.debug("Running YCSB on client: " + clients[i].ip_address)
				ssh = paramiko.SSHClient()
				ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
				ssh.connect(clients[i].ip_address, username=clients[i].username, password=clients[i].password)
				ssh.exec_command('cd /opt/YCSB; sh /opt/YCSB/run.sh > /opt/YCSB/read.log 2>&1 &')
				ssh.close()
			self.my_logger.debug("Running the " +str(j)+ " loop")
			time.sleep(2*27*self.period)
#			time.sleep(86400)
#			time.sleep(19200)
#			time.sleep(57600)
			#self.decisionMaker.the_action = "add_1"
			j = j + 1
		self.finished = True
	elif  self.utils.cluster_type == "HBASE94":
		minloadfile = open('/home/thanasis/Desktop/tiramola_mdp_real_sim_controller/minload','r')
		minload = minloadfile.readline().strip().split('.')[0];
		minloadfile.close()
		#they use an other way to get to hostname (see HBase94Cluster.py 41-52)
		master_instance = self.utils.get_instance_from_cluster_db(self.utils.cluster_name, self.utils.hostname_template+"master")
		loops = 1;
		threads = 1;	
		target = 3000;
	#	while(loops <= limit/3000):
		self.my_logger.debug('limit: ' + str(limit) + ' loop: ' + str(loops))
		ssh = paramiko.SSHClient()
		ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
		ssh.connect(clients[0].ip_address, username=clients[0].username, password=clients[0].password)
		ssh.exec_commandssh.exec_commandssh.exec_command('sh /root/YCSB-0.1.3/hbase-read-async.sh 1 200000 0 '+str(self.utils.hostname_template+"master")+' 2000000000 '+str(master_instance[2])+':'+str(self.utils.hostname_template+"master")+' '+str(loops)+ ' '+minload+' > /root/read.log 2>&1 &')
		ssh.close()
		time.sleep(50000)

	#	loops = loops + 1;
		self.my_logger.debug("finished")

#    def read_with_limit(self, clients, limit):
#	#they use an other way to get to hostname (see HBase94Cluster.py 41-52)
#	master_instance = self.utils.get_instance_from_cluster_db(self.utils.cluster_name, self.utils.hostname_template+"master")
#	loops = 1;
#	threads = 1;	
#	target = 3000;
#	while(loops <= limit/3000):
#		self.my_logger.debug('limit: ' + str(limit) + ' loop: ' + str(loops))
#		ssh = paramiko.SSHClient()
#		ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
#		ssh.connect(clients[0].ip_address, username=clients[0].username, password=clients[0].password)
#		ssh.exec_command('sh /root/YCSB-0.1.3/hbase-read-async.sh 1 18000 0 '+str(self.utils.hostname_template+"master")+' 2000000000 '+str(master_instance[2])+':'+str(self.utils.hostname_template+"master")+' '+str(loops)+ ' > /root/read.log 2>&1 &')
#		ssh.close()
#		time.sleep(1200)

#		loops = loops + 1;
#	self.my_logger.debug("finished")

    def initialize(self):
	#initialize client instances
	self.my_logger.debug("Initializing Clients")
	#add clients to db
	clients = self.run_clients(self.utils.clients_num, self.utils.clients_bucket_name, self.utils.client_disk, self.utils.client_cpu, self.utils.client_ram)
        clients = self.block_until_running(clients)
        self.my_logger.debug("Running client instances: " + str(clients))
	#clients.append(Client('delab1','192.168.1.5','root','passdelab1'))
	#clients.append(Client('delab2','192.168.1.7','root','passdelab2'))
	#clients.append(Client('leopard','192.168.1.4','root','secretpw'))
	self.my_logger.debug("sleeping for 1/2 minute")
	time.sleep(30)
	self.utils.add_to_clients_db(clients)
	self.configure_clients(clients)
	self.my_logger.debug("OK! Ready for loading")
	return clients

    def load(self):
	if self.utils.cluster_type == "INFINISPAN":
		self.my_logger.debug("Waiting for INFINISPAN to be initialized, sleep for 10 secs")
		time.sleep(10)
		self.my_logger.debug("Loading DB")
		self.load_db(self.utils.getClients())
	elif  self.utils.cluster_type == "CASSANDRA223":
		self.my_logger.debug("Waiting for CASSANDRA to be initialized, sleep for 10 secs")
		time.sleep(10)
		self.my_logger.debug("Loading DB")
		self.load_db(self.utils.getClients())
	elif  self.utils.cluster_type == "HBASE94":
		#creating usertable
		self.my_logger.debug("Waiting for HBASE to be initialized, sleep for 20 secs")
		time.sleep(10)
		self.my_logger.debug("Creating 'usertable' on master server")
		instance = self.utils.get_instance_from_cluster_db(self.utils.cluster_name, self.utils.hostname_template+"master")
		child = pexpect.spawn('ssh -o "StrictHostKeyChecking no" root@'+str(instance[2]))
	#        child.expect ('password:')
	#        child.sendline ('secretpw')
		child.expect (':~#')
		child.sendline ('/opt/hbase-0.94.20/bin/hbase shell')
		child.expect ('0>')
		child.sendline ('create \'usertable\', \'usertable\'')
		child.expect ('0>')
		self.my_logger.debug(child.before)
		child.close();

		self.my_logger.debug("Loading DB")
		self.load_db(self.utils.getClients())
	self.my_logger.debug("OK! Ready for experiments")

    def run(self, limit):
	#self.configure_clients(self.utils.getClients())
	#start running experiment
	self.my_logger.debug("Experiment Running")
	thread = Thread(target = self.run_experiment, args = (self.utils.getClients(), limit))
	thread.start()

    def stop_experiment(self):
	clients = self.utils.getClients()
	for client in clients:
		ssh = paramiko.SSHClient()
		ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
		self.my_logger.debug("Killing java on: " + str(client.ip_address)) 
		ssh.connect(client.ip_address, username=client.username, password=client.password)	
		ssh.exec_command('pkill -9 java')
		ssh.close()

    def get_occupied_dns_names(self):
	occupied = []
	kwargs = {
	    "headers": headers,
	    "auth": (self.username, self.password),
	    "verify": False,
	    "params":"bulk=1"
	}
	r = requests.request("get", self.base_url+"instances", **kwargs)
	list_answer = json.loads(r.content)
	for i in range(0,len(list_answer)):
	   occupied.append(str(list_answer[i]['name']));
	return occupied

    def run_clients(self, instance_count, os, disk, cpu, ram, pnode=None):
	occupied = self.get_occupied_dns_names();
	return self.run_clients_names(self.utils.getFree_dns_names(int(instance_count),occupied), os, disk, cpu, ram)
    
    def run_clients_names(self, names, os, disk, cpu, ram, pnode=None): 
        instances = []
	pending_instances = {}
	jobIDs = []
	running_vm_cnt = 0
        for name in names:
		print "running client instance: " + name
	        kwargs = {
	            "headers": headers,
	            "auth": (self.username, self.password),
	            "verify": False
	        }

                body = {
                    "__version__": 1,
                    "mode": 'create',
                    "hypervisor": 'kvm',
                    "os_type": os,
                    "instance_name": name,
                    "disk_template": 'plain',
                    "disks": [{'size':disk}],
                    "beparams": {"memory":ram,"maxmem":ram,"minmem":ram,'vcpus':cpu},
                    "hvparams": {'vnc_bind_address':'0.0.0.0'},
                    "nics": [{'ip':self.utils.mac_ip_mapping[name][1],'mac':self.utils.mac_ip_mapping[name][0]}]
                }
		if pnode:
			body['pnode'] = pnode
		else:
			if running_vm_cnt < 4:
				body['pnode'] = 'panther.delab.csd.auth.gr'
			else:
				body['pnode'] = 'deer.delab.csd.auth.gr'
                
                kwargs["data"] = json.dumps(body)

                r = requests.request("post", self.base_url+"instances", **kwargs)
                jobID = json.loads(r.content)
		jobIDs.append(jobID)

        	client = Client(name, self.utils.mac_ip_mapping[name][1], "root","secretpw");

		pending_instances[str(jobID)] = client
		running_vm_cnt = running_vm_cnt + 1

	failures = []
	for JID in jobIDs:
		status = ""
		while status != "success":
			time.sleep(5)
			kwargs = {
			    "headers": headers,
			    "auth": (self.username, self.password),
			    "verify": False
			}	

			body = {
			    "fields": ['status'],
			}

			kwargs["data"] = json.dumps(body)

			r = requests.request("get", self.base_url+"jobs/"+str(JID)+"/wait", **kwargs)
			status = json.loads(r.content)['job_info'][0]
#			print status
			if (status == 'error'):
				failures.append(JID)
				break
			elif(status == 'success'):
				instances.append(pending_instances[str(JID)]);

	#print failures
	self.tag_instances_owner(instances)
        return instances



    def tag_instances_owner(self, instances):
	jobIDs = []
	headersTag = {
	    "accept": "application/json",
	    "user-agent": "Ganeti RAPI Client",
	}
	for instance in instances:
		print "tagging instance: " + instance.id
	        kwargs = {
	            "headers": headersTag,
	            "auth": (self.username, self.password),
	            "verify": False
	        }

                body = {
                    "tag": ['owner:'+self.utils.ownerTag+'_client']
                }
                kwargs["params"] = body

                r = requests.request("put", self.base_url+"instances/"+instance.id+"/tags", **kwargs)
                jobID = json.loads(r.content)
		jobIDs.append(jobID)


    def block_until_running (self, instances):
        ''' Blocks until all defined instances have reached running state and an ip has been assigned'''
        ## Run describe instances until everyone is running
	running_instances = []
	remaining  = len(instances)
	for instance in instances:
		print "Waiting for", remaining, "instances to run"
		name = instance.id
	        kwargs = {
	            "headers": headers,
	            "auth": (self.username, self.password),
	            "verify": False
	        }
		status = ""
		timeout = 300
		while status != "running" and timeout > 0:
			time.sleep(5)
			r = requests.request("get", self.base_url+"instances/"+str(name), **kwargs)
            		status = json.loads(r.content)['status']
			timeout = timeout - 5
		if (timeout <= 0):
			print "timeout while waiting for running state: " + str(name)
		else:
			remaining = remaining - 1
			running_instances.append(instance)
        return self.block_until_ping(instances)


    def block_until_ping(self, instances):
        ''' Blocks until all defined instances have reached running state and an ip has been assigned'''
        ## Run describe instances until everyone is running
	ping_instances = []
	remaining  = len(instances)
	for instance in instances:
		print "Waiting for", remaining, "instances to ping"
		ping = False
		timeout = 150
		while (not ping and timeout > 0):
			response = os.system("ping -c 1 -W 4 " + instance.ip_address)
		        if response == 0:
			    ping = True;
		        else:
			    time.sleep(1);
			timeout = timeout - 1
		if (timeout <= 0):
			print "timeout while trying to ping: " + str(instance.ip_address)
		else:
			remaining = remaining - 1
			ping_instances.append(instance)
        return instances

            
if __name__ == "__main__":
    if len(sys.argv) == 3:
	clientsController = ClientsController(sys.argv[2])
	if 'init' == sys.argv[1]:
                clientsController.initialize();
        elif 'load' == sys.argv[1]:
                clientsController.load();
        elif 'run' == sys.argv[1]:
                clientsController.run()
	elif 'stop' == sys.argv[1]:
                clientsController.stop_experiment()
        else:
                print "Unknown command"
                sys.exit(2)
        sys.exit(0)
    else:
        print "usage: %s init|load|run properties_file" % sys.argv[0]
        sys.exit(2)

    

