#!/usr/bin/env python

import Utils,csv
#from ModelGenerator import ModelGenerator
from ModelGenerator_Security import ModelGenerator_Security
from scipy import misc
from datetime import datetime

class ModelHandler():  
	def __init__(self, properties_file):
		self.utils = Utils.Utils(properties_file)
		self.addProbsDict = {}
		self.removeProbsDict = {}
		self.modelFilePath = self.utils.modelFilePath
		self.modelMDPFilePath = self.utils.modelMDPFilePath
		self.prismFilePath = self.utils.prismFilePath
		self.propertiesFilePath = self.utils.propertiesFilePath
		self.propertiesProbabilisticFilePath = self.utils.propertiesProbabilisticFilePath
		self.initNumVms = self.utils.initial_cluster_size
		self.minNumVms = self.utils.min_cluster_size
		self.maxNumVms = self.utils.max_cluster_size
		self.maxAdd = self.utils.add_nodes
		self.maxRem = self.utils.rem_nodes
		self.num_of_clusters = self.utils.num_of_clusters
		self.gain = self.utils.gain
		self.latency_threshold = self.utils.latency_threshold
		self.max_steps = self.utils.max_steps
		self.cumulative = self.utils.cumulative
		self.attack = str(self.utils.attack)
		self.transient_counter_limit = str(self.utils.transient_counter_limit)
		self.only_attack = str(self.utils.only_attack)
		self.hourly = self.utils.hourly
		self.gain_punishment = self.utils.gain_punishment
		self.vm_types = self.utils.vm_types
		self.vm_types_limits = self.utils.vm_types_limits
		self.weightedReward = self.utils.weightedReward
		self.repViolationPunishement = self.utils.repViolationPunishement
		self.generateModel();
		
	def generateModel(self):
		parameters = {}
		parameters["initNumVms"] = self.initNumVms
		parameters["minNumVms"] = self.minNumVms
		parameters["maxNumVms"] = self.maxNumVms
		parameters["maxAdd"] = self.maxAdd
		parameters["maxRem"] = self.maxRem
		parameters["num_of_clusters"] = self.num_of_clusters
		parameters["gain"] = self.gain
		parameters["latency_threshold"] = self.latency_threshold
		parameters["modelFilePath"] = self.modelFilePath
		parameters["propertiesFilePath"] = self.propertiesFilePath
		parameters["propertiesProbabilisticFilePath"] = self.propertiesProbabilisticFilePath
		parameters["max_steps"] = self.max_steps
		parameters["cumulative"] = self.cumulative
		parameters["attack"] = self.attack
		parameters["transient_counter_limit"] = self.transient_counter_limit
		parameters["only_attack"] = self.only_attack
		parameters["hourly"] = self.hourly
		parameters["gain_punishment"] = self.gain_punishment
		parameters["vm_types"] = self.vm_types
		parameters["vm_types_limits"] = self.vm_types_limits
		parameters["weightedReward"] = self.weightedReward
		parameters["repViolationPunishement"] = self.repViolationPunishement
		pmcb = ModelGenerator_Security(parameters);
		pmcb.generateModel();

