import sys, logging
import shutil, os
import socket
import fileinput, paramiko, Utils, datetime
import xml.parsers.expat

class GParser:
    
    
    def __init__(self):
        self.inhost =0
        self.inmetric = 0
        self.allmetrics = {}
        self.currhostname=""
#        self.host = host
#        self.metric = metric

    def parse(self, file):
#        print datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")+" PARSE FUNCTION!!!"
        p = xml.parsers.expat.ParserCreate()
#        p.StartElementHandler = parser.start_element
#        p.EndElementHandler = parser.end_element
        p.StartElementHandler = self.start_element
        p.EndElementHandler = self.end_element
#        print file.read()

        p.ParseFile(file)
#        print datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")+" FILE PARSED!!!"
#        for line in file.readlines():
#            print "file line: "+ line
        
         
        if self.allmetrics == {}:
            raise Exception('Host/value not found')
        return self.allmetrics

    def start_element(self, name, attrs):
        # edo xtizo to diplo dictionary. vazo nodes kai gia kathe node vazo polla metrics.
        #print attrs
        if name == "HOST":
            #if attrs["NAME"]==self.host:
            self.allmetrics[attrs["NAME"]]={}
            # edo ftiaxno ena adeio tuple me key to onoma tou node kai value ena adeio dictionary object.
            self.inhost=1
            self.currhostname=attrs["NAME"]
#            print "molis mpika sto node me dns " , self.currhostname 
        
        elif self.inhost==1 and name == "METRIC": # and attrs["NAME"]==self.metric:
            #print "attrname: " , attrs["NAME"] , " attr value: " , attrs["VAL"]
            self.allmetrics[self.currhostname][attrs["NAME"]] = attrs["VAL"]

    def end_element(self, name):
            if name == "HOST" and self.inhost==1:
                self.inhost=0
#                print "molis vgika apo to node me dns " , self.currhostname
                self.currhostname=""
#                print self.allmetrics

class MonitorVms:
    def __init__(self, properties_file, cluster):
        self.utils = Utils.Utils(properties_file)
        self.cluster = cluster
        
        self.templates_path = os.path.abspath(os.path.join(os.getcwd(), os.pardir))+"/templates"

        self.ganglia_host = ""
        self.ganglia_port = 8649
        
        ## Install logger
        LOG_FILENAME = self.utils.install_dir+'/'+self.utils.logs_folder_name+'/Coordinator.log'
        self.my_logger = logging.getLogger('MonitorVms')
        self.my_logger.setLevel(self.utils.logging_level)
            
        handler = logging.handlers.RotatingFileHandler(LOG_FILENAME, maxBytes=2*1024*1024, backupCount=5)
        formatter = logging.Formatter("%(asctime)s - %(levelname)s - %(name)s - %(message)s")
        handler.setFormatter(formatter)
        self.my_logger.addHandler(handler)
        
#        self.host = ""
        #metric = 'swap_free'
        self.configure_monitoring()
        self.allmetrics={}
        self.parser = GParser()
        # initialize parser object. in the refreshMetrics function call the .parse of the 
        # parser to update the dictionary object.
#        print str(self.refreshMetrics())
        


    def refreshMetrics(self):
        try:
            self.soc = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
            self.soc.connect((self.ganglia_host,self.ganglia_port))
            self.allmetrics = None
            f = self.soc.makefile("r")
            self.allmetrics=self.parser.parse(f)
            f.close()
            f = None
            self.soc.close()
            #self.my_logger.debug("REFRESHMETRICS allmetrics: "+str(self.allmetrics))
        except socket.error:
            return self.allmetrics
        return self.allmetrics

    def configure_monitoring(self):
        ''' Gets a cluster objects and configures monitoring of the nodes using Ganglia. '''
        
        ## refresh cluster from db to make sure everything is correct in subsequent runs
        self.cluster = self.utils.get_cluster_from_db(self.utils.cluster_name)
	
        for clusterkey in self.cluster.keys():
            if clusterkey.endswith("master"):
                host_template = clusterkey.replace("master","")
                shutil.copy(self.templates_path+"/ganglia/gmond.conf", "/tmp/gmond.conf")
                for line in fileinput.FileInput("/tmp/gmond.conf",inplace=1):
                    line = line.replace("CLUSTER_NAME",host_template+"cluster").strip()
                    print line
                for line in fileinput.FileInput("/tmp/gmond.conf",inplace=1):
                    line = line.replace("GMETAD_IP", self.cluster[clusterkey].ip_address).strip()
                    print line
                    
        for (clusterkey, node) in self.cluster.items():
            ssh = paramiko.SSHClient()
            ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
            print node.ip_address
            try:
                ssh.connect(node.ip_address, username='root', password='secretpw')
            except paramiko.SSHException:
                self.my_logger.debug("Failed to invoke shell!")
                continue
            transport = paramiko.Transport((node.ip_address,22))
            transport.connect(username = 'root', password = 'secretpw')
            transport.open_channel("session", node.ip_address, "localhost")
            sftp = paramiko.SFTPClient.from_transport(transport)
            sftp.put( self.templates_path+"/ganglia/gmetad.conf","/etc/ganglia/gmetad.conf")
            sftp.put( "/tmp/gmond.conf","/etc/ganglia/gmond.conf")
            sftp.put( self.templates_path+"/ganglia/gmetad.conf","/etc/ganglia/gmetad.conf")
            sftp.put( "/tmp/gmond.conf","/etc/ganglia/gmond.conf")
            sftp.close()
            
            if clusterkey.endswith("master"):
                self.ganglia_host = node.ip_address
                
            ssh.close()
        
        ## Restart Ganglia on all nodes
        
        # Restart the master first, then all other nodes
        ssh = paramiko.SSHClient()
        ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
        master = self.cluster[host_template+"master"]
        try:
            ssh.connect(master.ip_address, username='root', password='secretpw')
            self.my_logger.debug("Start Ganglia on master")
            stdin, stdout, stderr = ssh.exec_command('/etc/init.d/ganglia-monitor stop')
            print stdout.readlines()
            stdin, stdout, stderr = ssh.exec_command('/etc/init.d/gmetad stop')
            print stdout.readlines()
            stdin, stdout, stderr = ssh.exec_command('/etc/init.d/gmetad start')
            print stdout.readlines()
            stdin, stdout, stderr = ssh.exec_command('/etc/init.d/ganglia-monitor start')
            print stdout.readlines()
            stdin, stdout, stderr = ssh.exec_command('/etc/init.d/apache2 restart')
            print stdout.readlines()
        except paramiko.SSHException:
            self.my_logger.debug("Failed to invoke shell!")
        finally:    
            ssh.close()
        
        i = 0
        # Do this twice
        for i in range(0, 2):
            for (clusterkey, node) in self.cluster.items():
                ssh = paramiko.SSHClient()
                ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
                print node.ip_address
                if not clusterkey.endswith("master"):
                    try:
                        ssh.connect(node.ip_address, username='root', password='secretpw')
                    except paramiko.SSHException:
                        self.my_logger.debug("Failed to invoke shell!")
                        continue
                
                    self.my_logger.debug("Start Ganglia on node "+ str(clusterkey))
                    stdin, stdout, stderr = ssh.exec_command('/etc/init.d/ganglia-monitor stop')
                    print stdout.readlines()
                    stdin, stdout, stderr = ssh.exec_command('/etc/init.d/gmetad stop')
                    print stdout.readlines()
                    stdin, stdout, stderr = ssh.exec_command('/etc/init.d/apache2 stop')
                    print stdout.readlines()
                    
                    ## Stop monitoring on nodes
                    stdin, stdout, stderr = ssh.exec_command('/etc/init.d/ganglia-monitor start')
                    print stdout.readlines()
                
                ssh.close()
            
        

def usage():
    print """Usage: check_ganglia \
-h|--host= -m|--metric= -w|--warning= \
-c|--critical= [-s|--server=] [-p|--port=] """
    sys.exit(3)

if __name__ == "__main__":
##############################################################
#    ganglia_host = 'clusterhead'
#    ganglia_port = 8649
#    host = 'clusterhead'
#    metric = 'swap_free'
#    warning = None
#    critical = None


#    try:
#        options, args = getopt.getopt(sys.argv[1:],
#          "h:m:w:c:s:p:",
#          ["host=", "metric=", "warning=", "critical=", "server=", "port="],
#          )
#    except getopt.GetoptError, err:
#        print "check_gmond:", str(err)
#        usage()
#        sys.exit(3)
#
#    for o, a in options:
#        if o in ("-h", "--host"):
#            host = a
#        elif o in ("-m", "--metric"):
#            metric = a
#        elif o in ("-w", "--warning"):
#            warning = float(a)
#        elif o in ("-c", "--critical"):
#            critical = float(a)
#        elif o in ("-p", "--port"):
#            ganglia_port = int(a)
#        elif o in ("-s", "--server"):
#            ganglia_host = a
#
#    if critical == None or warning == None or metric == None or host == None:
#        usage()
#        sys.exit(3)
    myUtil = Utils.Utils()
    mycluster = {}
    mycluster["db-image-master"] = myUtil.return_instance_from_tuple(("i-1","emi-1","62.217.120.125","62.217.120.125","running","eangelou","0","fdsf","c1.xlarge","sometime","Centos","eki-1","eri-1"))
    
    monVms = MonitorVms(mycluster)
    allmetrics=monVms.refreshMetrics()
    print "allmetrics: ", allmetrics
    allmetrics=monVms.refreshMetrics()
    print "allmetrics2: ", allmetrics

#    allmetrics=monVms.refreshMetrics()
#    print "allmetrics length ", len(allmetrics)


#    try:
#        print "ganglia host " + ganglia_host
#        print 'host ' + host
#        s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
#        s.connect((ganglia_host,ganglia_port))
##        file = s.makefile("r")
##        print file.read()
#        parser = GParser(host, metric)
##        print "outside function" , s.makefile("r")
#        value = parser.parse(s.makefile("r"))
#        
#        s.close()
#    except Exception, err:
#        print "CHECKGANGLIA UNKNOWN: Error while getting value \"%s\"" % (err)
#        sys.exit(3)
#
#    if value >= critical:
#        print "CHECKGANGLIA CRITICAL: %s is %.2f" % (metric, value)
#        sys.exit(2)
#    elif value >= warning:
#        print "CHECKGANGLIA WARNING: %s is %.2f" % (metric, value)
#        sys.exit(1)
#    else:
#        print "CHECKGANGLIA OK: %s is %.2f" % (metric, value)
#        sys.exit(0)
