# -*- coding: utf-8 -*-
# Generated by Django 1.10.5 on 2017-02-05 10:46
from __future__ import unicode_literals

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    dependencies = [
        ('elasticity', '0001_initial'),
    ]

    operations = [
        migrations.AlterModelOptions(
            name='elasticity',
            options={'verbose_name': 'Elasticity', 'verbose_name_plural': 'Elasticities'},
        ),
        migrations.AlterModelOptions(
            name='nosqlcluster',
            options={'verbose_name': 'NoSQL Cluster'},
        ),
        migrations.AlterModelOptions(
            name='nosqlinstance',
            options={'verbose_name': 'NoSQL Instance'},
        ),
        migrations.RemoveField(
            model_name='elasticity',
            name='dataset',
        ),
        migrations.RemoveField(
            model_name='elasticity',
            name='transaction_steps',
        ),
        migrations.AddField(
            model_name='elasticity',
            name='emulation_dataset',
            field=models.CharField(choices=[('okeanos', 'Cassandra on ~okeanos')], default='Cassandra on ~okeanos', max_length=300, verbose_name='Emulation Dataset'),
        ),
        migrations.AddField(
            model_name='elasticity',
            name='simulation',
            field=models.BooleanField(default=True, verbose_name='Simulate the Deployment'),
        ),
        migrations.AddField(
            model_name='elasticity',
            name='training_dataset',
            field=models.FilePathField(default='', verbose_name='Training Dataset'),
        ),
        migrations.AddField(
            model_name='elasticity',
            name='transition_steps',
            field=models.IntegerField(default=2, verbose_name='Transision Steps After VM Additions'),
        ),
        migrations.AlterField(
            model_name='elasticity',
            name='acceptance_percentage',
            field=models.FloatField(default=0.0, verbose_name='Utility Difference [0,1]'),
        ),
        migrations.AlterField(
            model_name='elasticity',
            name='attack_model',
            field=models.BooleanField(default=False, verbose_name='Consider Security Attacks'),
        ),
        migrations.AlterField(
            model_name='elasticity',
            name='cluster',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='elasticity.NoSQLCluster', verbose_name='NoSQL Database Cluster'),
        ),
        migrations.AlterField(
            model_name='elasticity',
            name='clusters_num',
            field=models.IntegerField(default=3, verbose_name='Num. of Meas. Clusters'),
        ),
        migrations.AlterField(
            model_name='elasticity',
            name='cumulative_reward',
            field=models.BooleanField(default=True, verbose_name='Use of Cumulative Rewards'),
        ),
        migrations.AlterField(
            model_name='elasticity',
            name='decision_policy',
            field=models.CharField(choices=[('probbexact', 'ORadv'), ('rf', 'BRsimple'), ('raf', 'BRecon'), ('probe', 'BR-BRecon'), ('probb', 'BR-BPstab'), ('probq', 'BR-BPqual')], default='BRsimple', max_length=300, verbose_name='Decision Policy'),
        ),
        migrations.AlterField(
            model_name='elasticity',
            name='hourly',
            field=models.BooleanField(default=True, verbose_name='Hourly Charging Consideration'),
        ),
        migrations.AlterField(
            model_name='elasticity',
            name='latency_threshold',
            field=models.IntegerField(default=45, verbose_name='Latency Threshold (ms)'),
        ),
        migrations.AlterField(
            model_name='elasticity',
            name='max_add',
            field=models.IntegerField(verbose_name='Max. Allowed VM Additions'),
        ),
        migrations.AlterField(
            model_name='elasticity',
            name='max_remove',
            field=models.IntegerField(verbose_name='Max. Allowed VM Removals'),
        ),
        migrations.AlterField(
            model_name='elasticity',
            name='max_vms',
            field=models.IntegerField(verbose_name='Max. Cluster Size'),
        ),
        migrations.AlterField(
            model_name='elasticity',
            name='min_vms',
            field=models.IntegerField(default=2, verbose_name='Min. Cluster Size'),
        ),
        migrations.AlterField(
            model_name='elasticity',
            name='prism_path',
            field=models.FilePathField(verbose_name='Training Dataset'),
        ),
        migrations.AlterField(
            model_name='elasticity',
            name='punishment',
            field=models.FloatField(default=2.0, verbose_name='Punishment Value'),
        ),
        migrations.AlterField(
            model_name='elasticity',
            name='smoothing',
            field=models.CharField(choices=[('wf', 'None'), ('wt', 'MA'), ('ewma', 'EWMA')], default='EWMA', max_length=300, verbose_name='Smoothing Window'),
        ),
        migrations.AlterField(
            model_name='elasticity',
            name='time_steps',
            field=models.IntegerField(default=15720, verbose_name='Time Steps (30secs/step)'),
        ),
        migrations.AlterField(
            model_name='elasticity',
            name='utility_function',
            field=models.CharField(choices=[('r1', 'throughput/num_nodes'), ('r2', '1.0/num_nodes'), ('r3', 'max_num_nodes-num_nodes+1'), ('r4', '1.0-(1.0/num_nodes)'), ('r42', '2.0-(2.0/(1+norm_total_cost))'), ('r10', '0.0*norm_total_cost+1.0*norm_latency'), ('r9', '0.1*norm_total_cost+0.9*norm_latency'), ('r8', '0.2*norm_total_cost+0.8*norm_latency'), ('r11', '0.35*norm_total_cost+0.65*norm_latency'), ('r7', '0.3*norm_total_cost+0.7*norm_latency'), ('r6', '0.4*norm_total_cost+0.6*norm_latency'), ('r5', '0.5*norm_total_cost+0.5*norm_latency'), ('r12', '0.6*norm_total_cost+0.4*norm_latency'), ('r13', '0.7*norm_total_cost+0.3*norm_latency'), ('r14', '0.8*norm_total_cost+0.2*norm_latency'), ('r15', '0.9*norm_total_cost+0.1*norm_latency'), ('r16', '1.0*norm_total_cost+0.0*norm_latency')], max_length=300, verbose_name='Utility Function'),
        ),
        migrations.AlterField(
            model_name='elasticity',
            name='verification_steps',
            field=models.IntegerField(default=4, verbose_name='Verification Steps'),
        ),
        migrations.AlterField(
            model_name='elasticity',
            name='violation_cluster',
            field=models.BooleanField(default=True, verbose_name='Use of Violation Cluster'),
        ),
        migrations.AlterField(
            model_name='nosqlcluster',
            name='cluster_type',
            field=models.CharField(choices=[('CASSANDRA39', 'Apache Cassandra 3.9'), ('HBASE', 'Apache HBase 0.98')], default='Apache Cassandra 3.9', max_length=200, verbose_name='NoSQL Database'),
        ),
        migrations.AlterField(
            model_name='nosqlcluster',
            name='init_cluster_size',
            field=models.IntegerField(default=2, verbose_name='Initial number of NoSQL nodes'),
        ),
        migrations.AlterField(
            model_name='nosqlcluster',
            name='owner',
            field=models.CharField(max_length=200, verbose_name='DB Owner'),
        ),
        migrations.AlterField(
            model_name='nosqlinstance',
            name='cluster',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='elasticity.NoSQLCluster', verbose_name='NoSQL Database Cluster'),
        ),
        migrations.AlterField(
            model_name='nosqlinstance',
            name='dns_name',
            field=models.CharField(max_length=200, verbose_name='DNS Name'),
        ),
        migrations.AlterField(
            model_name='nosqlinstance',
            name='image_id',
            field=models.CharField(max_length=200, verbose_name='snf-image ID'),
        ),
        migrations.AlterField(
            model_name='nosqlinstance',
            name='instance_type',
            field=models.CharField(max_length=200, verbose_name='Instance Type'),
        ),
        migrations.AlterField(
            model_name='nosqlinstance',
            name='ip_address',
            field=models.CharField(max_length=200, verbose_name='IP Address'),
        ),
        migrations.AlterField(
            model_name='nosqlinstance',
            name='launch_time',
            field=models.DateTimeField(auto_now_add=True, verbose_name='Launch Time'),
        ),
        migrations.AlterField(
            model_name='nosqlinstance',
            name='mac_address',
            field=models.CharField(max_length=200, verbose_name='MAC Address'),
        ),
        migrations.AlterField(
            model_name='nosqlinstance',
            name='password',
            field=models.CharField(max_length=200, verbose_name='Password'),
        ),
        migrations.AlterField(
            model_name='nosqlinstance',
            name='placement',
            field=models.CharField(max_length=200, verbose_name='Placement'),
        ),
        migrations.AlterField(
            model_name='nosqlinstance',
            name='state',
            field=models.CharField(max_length=200, verbose_name='State'),
        ),
        migrations.AlterField(
            model_name='nosqlinstance',
            name='username',
            field=models.CharField(max_length=200, verbose_name='Username'),
        ),
        migrations.AlterField(
            model_name='nosqlinstance',
            name='vpn',
            field=models.CharField(max_length=200, verbose_name='VPN'),
        ),
    ]
