import random,math,bisect,sys,collections
import numpy as np
from scipy.interpolate import InterpolatedUnivariateSpline 
from scipy.interpolate import UnivariateSpline
from scipy.cluster.vq import vq, kmeans, kmeans2, whiten

class LoadGenerator():
    def __init__(self, meas_count, inlambda_file_path, meas_file_path, new_lambda=True, f=False):
	start = 0
	step = 1.0
	random.seed(1)
	self.t={}
	self.inlambda = {}
	if new_lambda:
		ofile = open(inlambda_file_path, 'w')
		for i in range(0,meas_count+1):
			self.t[i]=start+i*step;
			if f:
#				self.inlambda[i] = 25000+20000*math.sin(0.002*i-(math.pi/2))+self.myR(-2000,2000);
#				self.inlambda[i] = 10000+6000*math.sin(0.002*i-(math.pi/2))#+self.myR(-2000,2000);


				if ((i > 4192) and (i < 5240)) or (i > 10480) and (i < 11528):
					if i_freeze == False:
						j = i;
						i_freeze = True
				else:
					i_freeze = False
					j = i;
#okeanos
				self.inlambda[i] = 10000+6000*math.sin(0.002*j-(math.pi/2))+self.myR(-500,500);
#gfplr
				#self.inlambda[i] = 46000+30000*math.sin(0.002*j-(math.pi/2))+self.myR(-2000,2000);
			else:
				self.inlambda[i] = 25000+20000*math.sin(0.002*i)+self.myR(-2000,2000);
			if(self.inlambda[i] > 15999):
				self.inlambda[i] = 15999;
			elif(self.inlambda[i] < 4000):
				self.inlambda[i] = 4000
			ofile.write(str(self.t[i])+"\t"+str(self.inlambda[i])+"\n")
		ofile.close()
	else:
		ifile = open(inlambda_file_path, 'rb')
		i = 0
		for line in ifile:
			self.t[i] = float(line.split("\t")[0]);
			self.inlambda[i] = float(line.split("\t")[1]);
			i = i + 1
		ifile.close()
	self.inlambda_index = 0;

	self.memory = {}
	meas = open(meas_file_path,'r')
	meas.next() # Skip the first line with the headers of the columns
	for line in meas:
	    m = line.split('\t\t')
	    self.addMeasurement(m)

    def addMeasurement(self, metrics):
	# metrics-> 0: state, 1: lambda, 2: thoughtput, 3:latency
	state = int(metrics[0])
	load = float(metrics[1])
	throughput = float(metrics[2])
	latency = float(metrics[3])

	if not self.memory.has_key(state):
            self.memory[state] = {}
            self.memory[state][load] = [(throughput, latency)]
        elif not self.memory[state].has_key(load):
            self.memory[state][load] = [(throughput, latency)]
        else:
            self.memory[state][load].append((throughput, latency))


    def myR(self, apo,ews):
	return ((ews-apo)*random.uniform(0,1))+apo;

    def thr(self, vm, inlambda):
	throughput = 0
	if self.memory.has_key(vm):
		if self.memory[vm].has_key(inlambda):
			if len(self.memory[vm][inlambda]) > 1:
				rand_select = random.randrange(0,len(self.memory[vm][inlambda])-1,1)
			else:
				rand_select = 0
#			throughput = self.memory[vm][inlambda][rand_select][0] + self.myR(-0.1*inlambda, 0.0)
			throughput = self.memory[vm][inlambda][rand_select][0]
		else:	
			state_load_list = self.get_state_load_list(vm)
			state_throughput_list = self.get_state_throughput_list(vm,state_load_list)

			next_lowest_load = self.get_next_lowest_load_from_state(vm, inlambda)
			next_biggest_load = self.get_next_biggest_load_from_state(vm, inlambda)
			if inlambda > next_lowest_load and inlambda < next_biggest_load:
				fc_thr = InterpolatedUnivariateSpline(state_load_list, state_throughput_list, k=1)
				throughput = fc_thr(inlambda) + self.myR(-0.1*inlambda, 0.0)
			else:
				fc_thr = UnivariateSpline(state_load_list, state_throughput_list, k=1)
				throughput = fc_thr(inlambda) + self.myR(-0.1*inlambda, 0.0)
		if throughput > inlambda or throughput < 0:
			throughput = inlambda
		return throughput
	else:
		return inlambda+self.myR(-0.1*inlambda, 0.0); 

    def random_pick(self,some_list, probabilities):
    	x = random.uniform(0, 1)
   	cumulative_probability = 0.0
    	for item, item_probability in zip(some_list, probabilities):
		cumulative_probability += item_probability
		if x < cumulative_probability: break
    	return item

    def random_pick2(self,l2):
	r = random.random()
	for (a,b) in l2:
		if r < b:
	    		return a
		else:
	   		r -= b

    def lat(self, vm, inlambda):

	latency = 0
	if self.memory.has_key(vm):
#		if self.memory[vm].has_key(inlambda):
#			if len(self.memory[vm][inlambda]) > 1:
#				rand_select = random.randrange(0,len(self.memory[vm][inlambda])-1,1)
#			else:
#				rand_select = 0
##			latency = self.memory[vm][inlambda][rand_select][1] + self.myR(0.0, 5.0)
#			latency = self.memory[vm][inlambda][rand_select][1]
#		else:	
		state_load_list = self.get_state_load_list(vm)
		inlambdaWindow = [i for i in state_load_list if (i >= inlambda*0.90 and i <= inlambda*1.1)]
		state_load_latency_list = self.get_state_load_latency_list(vm,inlambdaWindow)
		
		k=3
		if(state_load_latency_list == None or len(state_load_latency_list) == 0):
			return (0.0002*inlambda + self.myR(0.0, 5.0)); 
		latency = random.choice(state_load_latency_list)
		latency = self.myR(latency*0.95,latency*1.05)
		return latency

#		elif(len(state_load_latency_list[:,1]) < k):
#			k = len(state_load_latency_list[:,1])
#		centroids, label = kmeans2(np.array(state_load_latency_list[:,1],ndmin=2).reshape((-1,1)), k, minit='points')

#		counts = collections.Counter(label)
#		p=[counts[0]/float(len(label)),counts[1]/float(len(label)),counts[2]/float(len(label))]
##		print vm
##		print inlambda
##		print p
##		print [centroids[0][0],centroids[1][0],centroids[2][0]]
##			latency = self.random_pick([centroids[0][0],centroids[1][0],centroids[2][0]],p)	
#		c_p = []
#		for i in range(0,k):
#			c_p.append((centroids[i][0],counts[i]/float(len(label))))
#		#c_p = [(centroids[0][0],counts[0]/float(len(label))),(centroids[1][0],counts[1]/float(len(label))),(centroids[2][0],counts[2]/float(len(label)))]
#		latency = self.random_pick2(c_p)	
#		if latency < 0:
#			print 'lambda: ' + str(inlambda)
#			print 'vm: ' + str(vm)
#			print 'inlambdaWindow: ' + str(inlambdaWindow)
#			print 'centroids: ' + str(centroids)
#			print 'label: ' + str(centroids)
#			print 'counts: ' + str(counts)
#			print 'c_p: ' + str(c_p)
##		print latency
#		sys.stdout.flush()
#		return latency

#			next_lowest_load = self.get_next_lowest_load_from_state(vm, inlambda)
#			next_biggest_load = self.get_next_biggest_load_from_state(vm, inlambda)
#			if inlambda > next_lowest_load and inlambda < next_biggest_load:	
#				fc_lat = InterpolatedUnivariateSpline(state_load_list, state_latency_list, k=1)
#				latency = fc_lat(inlambda) + self.myR(0.0, 5.0)
#			else:
#				fc_lat = UnivariateSpline(state_load_list, state_latency_list, k=1)
#				latency = fc_lat(inlambda) + self.myR(0.0, 5.0)
#		if latency < 0:
#			latency = 10000

##		print vm
##		print inlambda
##		print latency
##		sys.stdout.flush()
#		return latency
	else:
		return (0.0002*inlambda + self.myR(0.0, 5.0)); 


    def get_state_load_list(self,vm):
	state_load = [];
	for l in self.memory[vm].keys():
		state_load.append(l)
	sorted_state_load = sorted(state_load)
	return np.array(sorted_state_load)

    def get_state_throughput_list(self,vm,load_list):
	state_throughput = [];
	for l in np.ndenumerate(load_list):
		rand_select = random.randrange(0,len(self.memory[vm][l[1]]),1)
		state_throughput.append(self.memory[vm][l[1]][rand_select][0])
	return np.array(state_throughput)

    def get_state_latency_list(self,vm,load_list):
	state_latency = [];
	for l in np.ndenumerate(load_list):
		rand_select = random.randrange(0,len(self.memory[vm][l[1]]),1)
		state_latency.append(self.memory[vm][l[1]][rand_select][1])
	return np.array(state_latency)

    def get_state_load_latency_list(self,vm,load_list):	
	state_latency = []
	for l in np.ndenumerate(load_list):
		rand_select = random.randrange(0,len(self.memory[vm][l[1]]),1)
		state_latency.append(self.memory[vm][l[1]][rand_select][1])
	return state_latency
#	state_latency = None
#	for l in np.ndenumerate(load_list):
#		rand_select = random.randrange(0,len(self.memory[vm][l[1]]),1)
#		if(state_latency == None):
#			state_latency = np.array([[l[1],self.memory[vm][l[1]][rand_select][1]]],ndmin=2);
#		else:
#			state_latency = np.append(state_latency, [[l[1],self.memory[vm][l[1]][rand_select][1]]], axis=0)
#	return state_latency

    def get_next_lowest_load_from_state(self, state, load):
	state_load = [];
	for l in self.memory[state].keys():
		state_load.append(l)
	sorted_state_load = sorted(state_load)
	lowest_index = bisect.bisect_left(sorted_state_load, load)
	return sorted_state_load[lowest_index-1] if lowest_index > 0 else sorted_state_load[0]

    def get_next_biggest_load_from_state(self, state, load):
	state_load = [];
	for l in self.memory[state].keys():
		state_load.append(l)
	sorted_state_load = sorted(state_load)
	return sorted_state_load[bisect.bisect_right(sorted_state_load,load)-1]


    def get_cur_load(self):
	load = 0;
	if self.inlambda_index < len(self.inlambda):
		load = self.inlambda[self.inlambda_index]
		self.inlambda_index = self.inlambda_index + 1;
	return load

    def get_next_load(self, steps):
	load = 0;
	if self.inlambda_index + steps < len(self.inlambda):
		load = self.inlambda[self.inlambda_index+steps]
	else: 
		load = self.inlambda[len(self.inlambda)-1]
	return load

	
    def get_meas(self,state):
	allmetrics = {};
	state = int(state)
	cur_load = self.get_cur_load()

	allmetrics['inlambda'] = cur_load
	allmetrics['throughput'] = self.thr(state,cur_load)
	allmetrics['latency'] = self.lat(state,cur_load)
	return allmetrics

if __name__ == '__main__':
	loadb = LoadGenerator(int(sys.argv[1]), sys.argv[2], sys.argv[3], False, True);
	for i in range(1,3000):
		print str(loadb.get_meas(6))
	
